/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_UI_PROPERTY_H__
#define __TK_DB_UI_PROPERTY_H__

#include <gtkmm.h>

#include "libtkdb/database.h"
#include "libtkdbui/value.h"

namespace Tk {
  namespace Db {
    namespace Ui {
      
      class Property : public Gtk::HBox
      {
      private:
	Tk::Db::Database     *_database;
	Tk::String            _domain;
	Tk::Db::Id            _entity_id;
	Tk::String            _name;
	Tk::Db::Data::Value   _value;
	Value                *_value_widget;
	Gtk::Button           _apply_button;
	
	void init();
	
      public:
	typedef sigc::signal<void, const Tk::String &, const Tk::Db::Id &, const Tk::String &, const Tk::Db::Data::Value &> SignalPropertySet;
	SignalPropertySet signal_property_set();
	
      protected:
	SignalPropertySet _signal_property_set;
	
	void value_changed(const Tk::Db::Data::Value &value);
	void apply_clicked();
	
      public:
	Property(Tk::Db::Database *database, const Tk::String &domain, const Tk::Db::Id &entity_id, const Tk::String &name, const Tk::Db::Data::Value &value);
	Property(Tk::Db::Database *database, const Tk::String &domain, const Tk::Db::Id &entity_id, const Tk::String &name, const Tk::Db::Data::Type &type);
	~Property();
      };
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace Tk */

#endif /* __TK_DB_UI_PROPERTY_H__ */
